Class SBlauncher : Weapon
{
	array<actor> bombs;
	Default
	{
		//$Category Weapons
		//$Sprite VSBLD0
		//$Title "Stickybomb Launcher"
		Weapon.AmmoGive 5;
		Weapon.AmmoUse 1;
		Weapon.AmmoType "RocketAmmo";
		Weapon.SlotNumber 5;
		Weapon.SlotPriority 0;
		Weapon.SelectionOrder 2400;
		+WEAPON.EXPLOSIVE;
		+WEAPON.NOAUTOAIM;
		+WEAPON.AMMO_OPTIONAL;
		+FLOORCLIP;
		Inventory.PickupMessage "You got the Sticky Bomb Launcher!";
		Inventory.PickupSound "misc/w_pkup";
		Obituary "%o was killed by %k's Sticky Bomb.";
		Weapon.WeaponScaleX 0.9;
		Weapon.WeaponScaleY 1.08;
	}
	States
	{
	Spawn:
		VSBL D -1;
		Stop;
	Select:
		VSBL A 1 
		{
			A_Raise();
			A_Overlay(2,"StopOverlay");
		}
		Loop;
	Deselect:
		VSBL A 1
		{
			A_Lower();
			A_Overlay(2,"StopOverlay");
		}
		Loop;
	Ready:
		VSBL A 1 
		{
			if (invoker.bombs.Size()> 0)
			{
				for (int i = invoker.bombs.Size(); i > 0; i--)
				{
					let bmb = invoker.bombs[i-1];
					if (invoker.bombs.Find(bmb) == invoker.bombs.Size()) invoker.bombs.delete(i-1);
				}
				A_Overlay(2,"ScreenBlueA");
			}
			else A_Overlay(2,"StopOverlay");
			A_WeaponReady();
		}
		Loop;
	Fire:
		TNT1 A 0 
		{
			if (!invoker.CheckAmmo(PrimaryFire,false,true))
			{
				if (invoker.bombs.Size()> 0)			
				{
					player.SetPsprite(PSP_WEAPON,invoker.FindState("Error"),true); 
				}
				else
				{
					invoker.bAMMO_OPTIONAL = false;
				}
			}
			else 
			{
				invoker.bAMMO_OPTIONAL = true;
				player.SetPsprite(PSP_WEAPON,invoker.FindState("Launch"),true); 
			}
		}
		Goto Ready;
	Launch:
		VSBL A 3 A_Startsound("SBLauncher/Shot");
		VSBL B 3
		{
			if (invoker.bombs.Size()> 0)
			{
				A_Overlay(2,"ScreenBlueB");
			}
			else A_Overlay(2,"StopOverlay");			
		}
		VSBL C 9 
		{
			A_Overlay(2,"StopOverlay");
			actor bmb = A_FireProjectile("StickyBomb",pitch:-5);
			if (bmb)
			{	
				bmb.pitch = invoker.owner.pitch;
				invoker.bombs.push(bmb);
			}
		}
		VSBL B 3 A_Overlay(2,"ScreenBlueB");
		Goto Ready;
	AltFire:
		VSBL A 0
		{
			if (invoker.bombs.Size()> 0) player.SetPsprite(PSP_WEAPON,invoker.FindState("Blast"),true); 
			else player.SetPsprite(PSP_WEAPON,invoker.FindState("Error"),true); 
		}
		Goto Ready;
	Blast:
		VSBL B 10 
		{
			A_Overlay(2,"ScreenGreenB");
			A_Startsound("SBLauncher/Detonate");
		}
		VSBL A 10
		{
			for (int i = invoker.bombs.size(); i > 0; i--)
			{
				let bmb = invoker.bombs[i-1];
				if (bmb && invoker.bombs.find(bmb) != invoker.bombs.size()) bmb.SetStatelabel("Explosion");
			}
			invoker.bombs.clear();
			A_Overlay(2,"ScreenGreenA");
		}
		Goto Ready;
	Error:
		VSBL B 10
		{
			A_Overlay(2,"ScreenRedB");
			A_Startsound("SBLauncher/Error");
		}
		VSBL A 10 A_Overlay(2,"ScreenRedA");
		Goto Ready;
	ScreenBlueA:
		VSBL F 1 Bright;
		Loop;
	ScreenGreenA:
		VSBL G 1 Bright;
		Loop;
	ScreenRedA:
		VSBL H 1 Bright;
		Loop;
	ScreenBlueB:
		VSBL I 1 Bright;
		Loop;
	ScreenGreenB:
		VSBL J 1 Bright;
		Loop;
	ScreenRedB:
		VSBL K 1 Bright;
		Loop;
	StopOverlay:
		Stop;
	}
}

class StickyBombAmmo : Ammo
{
	Default
	{
		//$Category Ammunition
		//$Sprite VSBLM0
		//$Title "Sticky Bomb"
		Inventory.Amount 1;
		Ammo.BackpackAmount 5;
		Inventory.MaxAmount 50;
		Ammo.BackpackMaxAmount 100;
		Inventory.PickupMessage "Picked up a Sticky Bomb.";
		Inventory.Icon "VSBLM0";
		scale 0.6;
	}
	States
	{
	Spawn:
		VSBL L -1;
		Stop;
	}
}

class StickyBombAmmoBox : StickyBombAmmo
{
	Default
	{
		//$Category Ammunition
		//$Sprite VSBLE0
		//$Title "Box of Sticky Bombs"
		Inventory.Amount 10;
		Inventory.PickupMessage "Picked up a box of Sticky Bombs.";
	}
	States
	{
	Spawn:
		VSBL E -1;
		Stop;
	}
}